apiVersion: monitoring.coreos.com/v1 # api from Prometheus operator that extends k8s api
kind: PrometheusRule # name of that resource
metadata:
  name: main-rules
  namespace: monitoring
  labels: # labels are used to identify k8s resources
    app: kube-prometheus-stack 
    release: monitoring
spec:
  groups:
  - name: main.rules
    rules:

    - alert: HostHighCpuLoad
      expr: 100 - (avg by(instance) (rate(node_cpu_seconds_total{mode="idle"}[2m])) * 100) > 50
      for: 2m # we give it 2 min period
      labels:
        severity: warning 
        namespace: monitoring # we need this to target the alert rule inside the alert manager configuration
      annotations:
        description: "CPU load on host is over 50%\n Value = {{ $value }}\n Instance = {{ $labels.instance }}\n"
        summary: "Host CPU load is over 50%\n Value = {{ $value }}\n"

    - alert: KubernetesPodCrashLooping 
      expr: kube_pod_container_status_restarts_total > 5
      for: 0m
      labels:
        severity: critical
        namespace: monitoring
      annotations: 
        description: "Pod {{ $labels.pod }} is crash looping\n Value = {{ $value }}"
        summary: "Kubernetes pod crash looping"

#### about the expression: expr: 100 - (avg by(instance) (rate(node_cpu_seconds_total{mode="idle"}[2m])) * 100) > 50
  # initial format copied from Prometheus UI
  # node_cpu_seconds_total is the metric we want to monitor
  # over period of 2 minutes, the rate of cpu idling
  # because we want to measure cpu usage per host, we have to group them by instance
  # 100 - idling time = actual usage

#### about k8s customed resource alert rule
# Prometheus Operator extends the Kubernetes API
# We create custom k8s resources
# Operator takes our custom k8s resource and tells Prometheus to reload the alert rules.
